centOS 6.5编译openJDK及问题

  • 作者:zccc
  • 来源:网络
  • 2020-07-14 12:04:00

系统运维 走进Java1 centOS 6.5下编译openJDK在进行此次操作的时候,作者一共安装并配置了三次linux虚拟机。第一次全是踩坑的。第二...

系统运维 走进Java1      centOS 6.5下编译openJDK

在进行此次操作的时候,作者一共安装并配置了三次linux虚拟机。第一次全是踩坑的。第二次是也踩了部分坑,尤其是2.9这个坑,直接导致了我的第三次,但是最终成功了!特写了这篇博客,希望对你有所帮助!

注意:请一定要注意相关安装文件的版本号!否则会有失败的风险!我所用到的相关文件资源,我已经上传到51CTO。下载地址在文章末尾处!!!


1.1    linux环境准备

linux环境准备:Oracle VMware virtualBox 11.0.0并安装CentOS 6.5

(安装方法参考网上资料)

CentOS 是一个基于Red Hat Linux 提供的可自由使用源代码的企业级Linux发行版本。

本次编译采用的是64位的OS,编译也是64位的JDK,内存1G,硬盘:20G

实现流程参考资料

 

(阅读README和README-builds.html)

 

README-builds.html中包含有详细的安装信息,最好能完整的阅读一下。

最小化安装和安装基础软件包(可省略)

 

安装时使用最小化(Minimal)安装

 

[root@localhost~]# cat /etc/RedHat-release

CentOS release 6.5(Final)

[root@localhost~]# uname -m

x86_64

[root@localhost~]# uname -r

2.6.32-431.el6.x86_64

 

配置更新源

 

cd/etc/yum.repos.d/

curlhttp://mirrors.163.com/.help/CentOS6-Base-163.repo > CentOS6-Base-163.repo

 

当前wget还不能用

 

#wgethttp://mirrors.163.com/.help/CentOS6-Base-163.repo

mvCentOS-Base.repo CentOS-Base.repo.bak

mvCentOS6-Base-163.repo CentOS-Base.repo

yum makecache

 

yum -ygroupinstall 'base'

yum -y installmake

 

创建三个目录:

# mkdir/usr/tools/

# mkdir /usr/java/

# mkdir /usr/jdks/

上传文件工具:Xftp(默认)或者安装lrzsz

    卸载linux自带的jdk

安装完成后,进入linux系统:

linux自带的jdk,

如果安装了OpenJDK,可用如下方法进行卸载:

rpm -qa | grepjava

 

rpm -e --nodepsjava-1.7.0-openjdk-1.7.0.45-2.4.3.3.el6.x86_64

rpm -e --nodepsjava-1.6.0-openjdk-1.6.0.0-1.66.1.13.0.el6.x86_64

注意:

 

rpm -e xxx //普通删除模式

rpm -e --nodeps xxx // 强力删除模式,如果使用上面命令删除时,提示有依赖的其它文件,则用该命令可以对其进行强力删除,可能会导致意外错误,系统破坏。

1.3    安装JDK1.6

下面贴出README-builds.html中原文:

Bootstrap JDK

All OpenJDK builds require access to thepreviously released JDK 6, this is often called a bootstrap JDK. The JDK 6binaries can be downloaded from Sun‘s JDK 6 download site. For buildperformance reasons is very important that this bootstrap JDK be made availableon the local disk of the machine doing the build. You should always setALT_BOOTDIR to point to the location of the bootstrap JDK installation, this isthe directory pathname that contains a bin, lib, and include It‘s also a goodidea to also place its bin directory in the PATH environment variable, althoughit‘s not required.

配置引导JDK。

《深入理解Java虚拟机》中片段:

要准备一个6u14以上版本的JDK(JDK1.6以上版本),因为openJDK的各个组成部分(Hotspot、JDK API 、JAXWS、JAXP……)有的是使用C++编写的,更多的代码是使用Java自身实现的,因此编译这些Java代码需要用到一个可用的JDK,官方称这个JDK为“Bootstrap JDK”。Bootstrp JDK必须为JDK6 update 14或之后版本!

 

必须安装jdk1.6,因为在编译的过程中,需要依赖jdk1.6初始化VM虚拟机,编译一些java文件!

特别说明:jdk和openJDK是不一样的,具体描述请百度!

jdk1.6下载地址:http://down.51cto.com/data/2306446

将下载好的jdk1.6上传到/usr/java/目录下:

给用户添加可执行的权限

 

#chmod +x jdk-6u45-linux-x64.bin  或 # chmod 755jdk-6u45-linux-x64.bin

 

#./ jdk-6u45-linux-x64.bin

 

# ll

配置环境变量,然后测试:

# java –version

 

【注意:如果你安装的JDK1.7或以上版本,在执行最后的make操作时会报错:参阅:2.6】

 

1.4    下载openJDK 1.71.4.1    推荐下载openJDK方法

openJDK下载地址:http://www.java.net/download/openjdk/jdk7u6/promoted/b24/openjdk-7u6-fcs-src-b24-28_aug_2012.zip

 

使用Xftp插件上传已经下载好的openJDK,上传到/usr/jdk/目录下

 

# unzip openjdk-7u6-fcs-src-b24-28_aug_2012.zip

再删除原文件:(也可不删除备用)

 

【安装openJDK1.7不推荐方法,请参阅:2.1】

1.5    编译openJDK相关依赖包

注意,必须先回到根目录:

[root@openjdk usr]# cd /

1.5.1    安装必备软件包:

yum -y install alsa-lib-devel

yum -y install cups-devel

yum -y install libXi-devel

yum -y install gccgcc-c++

yum -y install libX*

1.5.2    安装freetype

freetype  下载地址:http://sourceforge.net/projects/freetype/files/freetype2/

 已经下载好的freetype-2.5.5资源地址:http://down.51cto.com/data/2306445

进入tools目录:

# cd /usr/tools/

【注意:安装freetype会有版本编译错误问题!第一次安装的是freetype-2.5.2,结果编译失败!参阅2.2。最终选择了freetype2.5.5】

 

1.5.2.1             方式一:(不推荐,速度太慢)

安装freetype2.5.5版本:

//下载地址可能会变的,根据自己需要填写路径以及相关版本

[root@openjdk tools]# wget https://www.sourceforge.net/projects/freetype/files/freetype2/2.5.5/freetype-2.5.5.tar.gz

或wget http://download.savannah.gnu.org/releases/freetype/freetype-2.5.5.tar.gz 

注意:可能会存在下载不来,或速度很慢的情况。推荐方式二!

报错:


tar -xvf freetype-2.5.5.tar.gz 
cd freetype-2.5.5 
./configure

 make

make install

成功!!!

或:

freetype 也可以用 yum 的方式安装:(未尝试)

 

yum install gcc gcc-c++ freetype-develglib2-devel cairo-devel

1.5.2.2             方式二

freetype-2.5.5.tar.gz  下载地址:http://sourceforge.net/projects/freetype/files/freetype2/

手动下载freetype2.5.5:

使用Xftp将文件上传到/usr/tools/目录下:

解压:

# tar –xvf freetype-2.5.5.tar.gz

# cd freetype-2.5.5 
#./configure

# make

# make install

 

1.5.3    安装ant

ant 下载地址:http://archive.apache.org/dist/ant/binaries/

已经下载好的apache-ant-1.9.6资源地址:http://down.51cto.com/data/2306443

# cd /application/tools/

同样两种方式:

方式一:(下载速度有点慢)

# wget http://archive.apache.org/dist/ant/binaries/apache-ant-1.9.6-bin.zip 
# unzip apache-ant-1.9.6-bin.zip 

方式二:

从官网先下载ant源码,再使用Xftp上传到linux系统中:

# unzip apache-ant-1.9.6-bin.zip 或 tar –xvfapache-ant-1.9.6-bin.tar.gz

# ln -s /usr/tools/apache-ant-1.9.6/bin/ant/usr/bin/ant

//ln –s 为某一个文件或目录在另外一个位置建立一个同步的链接

链接之后,ant命令可用!

1.5.4    检查以上配置:

1.6    编译1.6.1    设置环境变量1.6.1.1             官方给的配置:(不建议使用)

注意:相关参数未修改。

#设置语言 

 export 

 export ALT_BOOTDIR=/usr/lib/jvm/jdk1.7.0/

  #允许自动下载依赖包 

 export ALLOW_DOWNLOADS=true 

 

  #使用预编译头文件,不加这个编译会更慢 

 export USE_PRECOMPILED_HEADER=true 

 

  #要编译的内容 

 export BUILD_LANGTOOLS=true 

 export BUILD_JAXP=true 

 export BUILD_JAXWS=true 

 export BUILD_CORBA=true 

 export BUILD_HOSTPOT=true 

 export BUILD_JDK=true 

 

  #要编译的版本 

 export SKIP_DEBUG_BUILD=false 

 export SKIP_FASTDEBUG_BUILD=true 

 export DEBUG_NAME=debug 

 

  #把它设置为FALSE可以避免javaws和浏览器Java插件之类的部分build 

 BUILD_DEPLOY=false 

 

  #把它设置为false就不会build出安装包。因为安装包里有一些奇怪的依赖 

  #但即便不build出它也已经得到完整的JDK镜像,所以还是不用build它 

 BUILD_INSTALL=false 

 

  #存放编译结果 

 export ALT_OUTPUTDIR=/home/lzl/openjdk/build 

 

 unset CLASSPATH 

 unset JAVA_HOME 

 make 2>&1 | tee $ALT_OUTPUTDIR/build.log 

1.6.1.2             实际配置

unset CLASSPATH

unset JAVA_HOME

export

export ALT_BOOTDIR=/usr/java/jdk1.6.0_45 # 预装的jdk7目录

exportANT_HOME=/usr/tools/apache-ant-1.9.6  #ant安装目录

exportALT_FREETYPE_HEADERS_PATH=/usr/local/include/freetype2 #freetype2头文件安装目录

exportALT_FREETYPE_LIB_PATH=/usr/local/lib #freetype2 lib目录

export ARCH_DATA_MODEL=64  #64位

export SKIP_DEBUG_BUILD=false 

 

export SKIP_FASTDEBUG_BUILD=true 

 

export DEBUG_NAME=debug 

# 输出路径

export ALT_OUTPUTDIR=/usr/openjdk

 

 

 

配置完成,生效!

#source /etc/profile

 

【在配置环境变量的时候,遇到一个错误:参阅:2.3】

1.6.2    make sanity检查

检查环境是否配置OK与编译jdk源码

#cd /usr/jdk/

# cd openjdk

# pwd

# make sanity

成功!

 

【第一次走到这一步的时候,犯了一个jdk和openJDK相同的概念错误,参阅:2.4】

1.6.3    make编译

如果之前编译过,请先进行clean:

#make clean

#make all

最终:看到了成功!!!

 

 

【第一次make all由于jdk版本的问题,遇到了一个错误,参阅:2.5】

重复:make clean 和make all

【第二次make all由于CurrentDate.properties时间配置文件的问题,遇到了一个错误,参阅:2.7和2.8】

重复:make clean 和make all

【硬盘空间不足的错误,参阅:2.9】

1.7    跑一下自己编译的虚拟机1.7.1    方式一(推荐)

再查看编译成功后的JDK版本:

由于配置安装输出路径,进入配置的路径下:

         进入usr/openjdk/bin目录,输入./java –version

到这一步,编译openJDK算成功了!

 

【注意:如果在配置环境变量的时候,没有配置输出路径#exportALT_OUTPUTDIR=/usr/openjdk;默认会在openjdk目录下,创建一个build目录存放output数据,那就变成了:

进入openjdk/build/bin目录,输入./java –version

1.7.2    方式二

进入目录

(默认情况下:路径是: /openjdk/build/linux-amd64/hotspot/outputdir/linux_amd64_compiler2)

配置输出路径后的hotspot目录是:

[root@openjdkhotspot]# cd /usr/openjdk/hotspot/

# cd  outputdir/linux_amd64_compiler2

# ll

下面有好几种优化级别的编译版本:

进入到product目录中:

# cd product/

# ll

这里要在env.sh配置下环境变量,指向共享库:(路径根据实际情况调整配置)

 

LD_LIBRARY_PATH=.:${JAVA_HOME}/jre/lib/amd64/native_threads:${JAVA_HOME}/jre/lib/amd64:/opt/openJDKroom/openjdk/build/linux-amd64/hotspot/outputdir/linux_amd64_compiler2/product

export LD_LIBRARY_PATH

 

下面贴出我这个文件的完整内容:

 

# Generated by /usr/jdk/openjdk/hotspot/make/linux/makefiles/buildtree.make

#: ${JAVA_HOME:=/usr/java/jdk1.6.0_45}

JAVA_HOME=/usr/openjdk/j2sdk-p_w_picpath #这个配置根据具体情况而定:默认是:/usr/openjdk/build/linux-amd64/j2sdk-p_w_picpath

CLASSPATH=.:${JAVA_HOME}/jre/lib/rt.jar:${JAVA_HOME}/jre/lib/i18n.jar

HOTSPOT_BUILD_USER="root inhotspot"

export JAVA_HOME CLASSPATHHOTSPOT_BUILD_USER

 

# add

#后面的那段路径,默认配置是:/usr/openjdk/build/linux-amd64/hotspot/outputdir/linux_amd64_compiler2/product

LD_LIBRARY_PATH=.:${JAVA_HOME}/jre/lib/amd64/native_threads:${JAVA_HOME}/jre/lib/amd64:/usr/openjdk/hotspot/outputdir/linux_amd64_compiler2/product

export LD_LIBRARY_PATH

 

下面执行:

 

# source ./env.sh

# cd ..

回到上一级目录,进入:/usr/openjdk/hotspot/outputdir/linux_amd64_compiler2/jvmg

# cd jvmg/

# ./test_gamma

 

运行成功!!

1.8    在NetBeans编译运行HotSpot

参考博客:http://www.cnblogs.com/zyx1314/p/5638596.html

2      踩的坑2.1    安装openJDK1.7不推荐方法(前提是用centOS):

【ubuntu虚拟机推荐使用】具体参考网址如下:
http://openjdk.java.net/install/index.html

$ sudo apt-getinstall openjdk-7-jre

 

原因:CentOS的软件安装工具不是apt-get 是yum

yum (YellowdogUpdater Modified)是一个集与查找,安装,更新和删除程序的Linux软件。


# yum install xxx  so….

2.1.1    问题       

No package openjdk-7-jre available. Error:Nothing to do

 

【解决这个一连串问题的时候:请备份libperl.so(必须):如果后续报错:

: error while loading shared libraries:/usr/lib64/perl5/CORE/libperl.so: file too short

 

此时,libperl.so备份文件,还原就可以,操作导致libperl.so为空,所以还原后。就解决完成,相关组件可正常使用。】

 

查看yum服务上的openjdk安装包:

[root@openjdk java]# yum list | grepopenjdk

更新yum仓库:(慎用!!!不要随便yumupdate 后果有时会导致系统启动不了,因为它会更新你的内核,停止后,进系统,最好yum clean all)

[root@openjdk java]# yum -y update

**************************(接下来1个小时等待中。。。)实际操作中可跳过此步骤!!!

通过yum的查找参数来列出openjdk相关的包名:

[root@openjdk java]# yum search openjdk

安装yum仓库中存在的版本:

[root@openjdk java]# yum install java-1.7.0-openjdk.x86_64;

测试是否安装成功:

 

2.2    安装freetype2.5.2(版本问题错误)

freetype-2.5.2.tar.gz  下载地址:http://sourceforge.net/projects/freetype/files/freetype2/

手动下载freetype2.5.2:

使用Xftp将文件上传到/usr/tools/目录下:

解压:

tar –xvf freetype-2.5.2.tar.gz

cd freetype-2.5.2 
./configure

出错:解决方案:

进入:[root@openjdk freetype-2.5.2]# cd builds/unix/

[root@openjdk unix]# ./configure

再回到freetype-2.5.2 目录下,执行make:

cd ..

cd ..

make

[root@openjdk freetype-2.5.2]# make

config.mk:25: builds/unix/unix-def.mk: 没有那个文件或目录

config.mk:26: builds/unix/unix-cc.mk: 没有那个文件或目录

make: *** 没有规则可以创建目标“builds/unix/unix-cc.mk”。停止。

网上找了一下。没有相关解决方案:

“下载了几个版本的freeType以源码的方式安装(configure/ make && make install),总也不行。。。”同病相怜

查看了一下权限,准备给予root权限再试:并手动创建这两个文件。

不能解决问题。删除freetype相关资料。

 

换个版本2.5.5,解决问题!

# make install

2.3    配置环境变量报错

说明:第一次配置编译的时候,安装的是jdk1.7的,可忽略,和本次错误无关!

报错:

肯定是profile配置文件编写有问题:

export `=' not a valid identifier的一般原因 

原因就是修改的 /etc/profile 文件里

加过空格!!!

除去空格,解决问题!

2.4    make sanity错误

【报错:

make:*** No rule to make target `sanity'. Stop.

上述问题的产生的根本原因是工程更改路径或者更改了其中的文件夹名称之后,之前生成的.o.d文件在再次编译时并不会重新编译,因而导致该问题。根源解决办法是删除编译后生成的obj文件夹。然后重新编译就行了。

主要是因为前期并没有下载openJDK,还是直接使用的jdk进行编译!!!原谅我的无知!重新处理后:

成功!

2.5    make all错误

报错:jdk1.7在初始化VM的时候发生错误!

Using java runtime at:/usr/java/jdk1.7.0_75/jre

Error occurred duringinitialization of VM

这个问题的解决方案:http://stackoverflow.com/questions/26804355/cannot-compile-openjdk7-source-code-on-centos6-5

Download and install Oracle JDK 1.6.0_45and set it to "ALT_BOOTDIR" and "ALT_JDK_IMPORT_PATH",please do not use OpenJDK1.7

解决方案:

更换JDK版本,重新配置jdk1.6.0_45版本,并执行# make(参考2.6)

 

2.6    更改JDK版本

删除jdk1.7目录以及目录下文件

安装jdk1.6

将下载好的jdk1.6上传到/usr/java/目录下:

给用户添加可执行的权限

 

#chmod +x jdk-6u45-linux-x64.bin  或 # chmod 755jdk-6u45-linux-x64.bin

 

#./ jdk-6u45-linux-x64.bin

 

# ll

更改环境变量配置

保存生效

#source /etc/profile

进入/usr/jdk/openjdk目录,执行1.5.3

 

2.7    Error: time is more than 10years from present: 1136059200000

解决方案参考博客:http://www.bubuko.com/infodetail-1306571.html

data.temp \

                   <../../../src/share/classes/java/util/CurrencyData.properties

Error: time is more than 10 years frompresent: 1136059200000

java.lang.RuntimeException: time is more than10 years from present: 1136059200000

 

修改CurrentDate.properties时间配置文件(里面存在2004,2005,2006年),把10年之前的时间修改为10年之内即可(把所有的时间格式的时间改为2017以前的十年以内的年数)

文件路径:/usr/jdk/openjdk/jdk/src/share/classes/java/util/CurrencyData.properties

 

下面介绍了对应补丁的出处

https://bugs.gentoo.org/show_bug.cgi?id=534118#c3

下面有关于问题原因探讨描述

https://bugs.gentoo.org/show_bug.cgi?id=534118#c7

 

如果不想仔细看可以直接访问补丁网址:

http://hg.openjdk.java.net/jdk7u/jdk7u/jdk/rev/74a70385c21d#l11.1

CurrentDate.properties文件地址:http://hg.openjdk.java.net/jdk7u/jdk7u/jdk/file/74a70385c21d/src/share/classes/java/util/CurrencyData.properties

请先备份CurrentDate.properties文件!!!必须养成linux系统上修改文件前,进行文件备份的习惯!!!

将其中的文件内容拷贝下来覆盖到对应CurrentDate.properties文件中。

注意:千万不要覆盖。否则会有新问题:2.8

 

2.8    Error: currency code not listedas valid: EUR

data.temp \

                   <../../../src/share/classes/java/util/CurrencyData.properties

Error: currency code not listed as valid:EUR

java.lang.RuntimeException: currency codenot listed as valid: EUR

 

这个是直接覆盖后导致的错误,说明配置文件除了年份之外,内容也有改动!

我自己修改后的文件CurrencyData.properties:下载地址参考文章末尾处!!!


本文参考博文:

http://www.linuxidc.com/Linux/2015-05/117248.htm

http://www.bubuko.com/infodetail-1306571.html

 

2.9    硬盘空间不足

【错误:内存不足!!!解决方案:重新安装linux虚拟机。。。】当时的硬盘是8G!!!


3      相关资料下载地址

apache-ant-1.9.6资源地址:http://down.51cto.com/data/2306443

CurrentDate.properties资源地址:http://down.51cto.com/data/2306442

freetype-2.5.5资源地址:http://down.51cto.com/data/2306445

jdk-6u45-linux-x64.bin(jdk1.6版本)资源地址:http://down.51cto.com/data/2306446,说明由于单次资料上传只能为50M,68M多jdk1.6分为两部分。
解压的时候,解压到同一个文件夹下即可。



<a href=http://www.xinnet.com target=_blank>新网</a><a href=http://www.xinnet.com target=_blank>虚拟主机</a>

  • 相关专题

免责声明:本文内容由互联网用户自发贡献自行上传,本网站不拥有所有权,也不承认相关法律责任。如果您发现本社区中有涉嫌抄袭的内容,请发送邮件至:operations@xinnet.com进行举报,并提供相关证据,一经查实,本站将立刻删除涉嫌侵权内容。

相关文章

免费咨询获取折扣